#include "pesp.h"

extern pespBuff_t pespBuff;
extern buff_Dt_t  buff_Dt[MAX_FD_NR];


//---------------------------------------------------------------------------
int pesp_open(struct inode *inode, struct file *filp)
{
  int ch;

  unsigned int dev_minor = iminor(inode);

  if (dev_minor == 0 ) { // pespImg0, vecchio device
	if       (pespBuff.buff[1].opened == -1 )  filp->private_data = (void *)1;
	else if  (pespBuff.buff[2].opened == -1 )  filp->private_data = (void *)2;
	else if  (pespBuff.buff[3].opened == -1 )  filp->private_data = (void *)3;
	else if  (pespBuff.buff[4].opened == -1 )  filp->private_data = (void *)4;

	else {
		return -EMFILE;
	}
  
	ch = (uintptr_t)filp->private_data;
	pespBuff.buff[ch].opened=1;
	pespBuff.buff[ch].pid=current->pid;
	strncpy(pespBuff.buff[ch].comm, current->comm, sizeof(current->comm));
	printk(KERN_ALERT "pesp_open(): opened file descr. %lu by PID: %d : %s\n", (uintptr_t)filp->private_data, current->pid, current->comm);
	return 0; /* Success */
  } else
  if (dev_minor == 1 ) { // pespDt0, nuovo device
	if       (buff_Dt[1].opened == -1 )  filp->private_data = (void *)101;
	else if  (buff_Dt[2].opened == -1 )  filp->private_data = (void *)102;
	else if  (buff_Dt[3].opened == -1 )  filp->private_data = (void *)103;
	else if  (buff_Dt[4].opened == -1 )  filp->private_data = (void *)104;

	else {
		return -EMFILE;
	}
	printk(KERN_ALERT "pesp_open(): opened file on minor 1 by PID: %d : %s\n", current->pid, current->comm);
	return 0; /* Success */
  }
  return -ENXIO; /* No such device or address */
}
