#include "pesp.h"

extern pespBuff_t pespBuff;
extern buff_Dt_t  buff_Dt[MAX_FD_NR];

//---------------------------------------------------------------------------
unsigned int pesp_poll(struct file *filp, poll_table *pt){
  unsigned int mask;
  int x = 0;
  
  unsigned int dev_minor = iminor(filp->f_path.dentry->d_inode);

  #ifdef _DBG
 	printk(KERN_DEBUG "\n ... pesp_poll():\n");
  #endif

  mask = 0;
  if ( dev_minor == 0 ){   // pespImg0, vecchio device
  	x = atomic_read(&(pespBuff.buff[(uintptr_t)filp->private_data].st));
  } else
  if (dev_minor == 1 ) { // pespDt0, nuovo device
        printk(KERN_ALERT "pesp_poll(): poll file on minor 1 by PID: %d : %s\n", current->pid, current->comm);
  	x = atomic_read(&(buff_Dt[((uintptr_t)filp->private_data)-100].st));
  }
  	switch (x){
		case 1:		// img disponibile
	  		mask |= POLLIN | POLLRDNORM;
	  		break;
		case 0:  	// Nessuna img
		case -1: 	// Gia' letta
		default:
	  		break;
  	};
  
  poll_wait(filp, &(pespBuff.queue), pt);

  #ifdef _DBG
  	printk(KERN_DEBUG "pesp_poll(): after poll_wait\n");
  #endif

  return mask;
};
