#include "pesp.h"


extern pespBuff_t pespBuff;
extern buff_Dt_t  buff_Dt[MAX_FD_NR];


extern unsigned long rd_usecs;

extern struct timeval rd_begin_time[MAX_FD_NR];
extern struct timeval rd_end_time[MAX_FD_NR];


//---------------------------------------------------------------------------
ssize_t pesp_read(struct file *filp, char *buf, 
                    size_t count, loff_t *f_pos)
{ 
  int retval;
  int x;

  int ch;

  unsigned int dev_minor = iminor(filp->f_path.dentry->d_inode);

  if ( dev_minor == 0 ){  // pespImg0, vecchio device

	ch = (uintptr_t)filp->private_data;

	do_gettimeofday(&rd_begin_time[ch]);

	#ifdef _DBG
		printk(KERN_DEBUG "pesp_read(): \n");
	#endif

	x = atomic_read(&(pespBuff.inited));
	if (x != 1) {
  		printk(KERN_DEBUG "pesp_read(): called pespBuff.inited=%d\n", x);
		return 0;
	} 

	mutex_lock(&pespBuff.buff[ch].mtx);

	if ( pespBuff.buff[ch].wr_count <= 0 ) {
		retval = count;
	} else {
		if ( count > pespBuff.buff[ch].wr_count) {
			count = pespBuff.buff[ch].wr_count;
		};

  		/* Transfering data to user space */ 
  		retval = copy_to_user(buf,pespBuff.buff[ch].buff,count);
  		atomic_set(&(pespBuff.buff[ch].st), -1);
  	};

	mutex_unlock(&pespBuff.buff[ch].mtx);

	*f_pos = 0;

	do_gettimeofday(&rd_end_time[ch]);
	rd_usecs = (rd_end_time[ch].tv_sec - rd_begin_time[ch].tv_sec)*1000000 + (rd_end_time[ch].tv_usec - rd_begin_time[ch].tv_usec);

	return (count-retval);

  } else
  if (dev_minor == 1 ) { // pespDt0, nuovo device
	ch = (uintptr_t)filp->private_data - 100;
 	atomic_set(&(buff_Dt[ch].st), -1);

       	printk(KERN_ALERT "pesp_read(): read file on minor 1 by PID: %d : %s\n", current->pid, current->comm);
       	return 0; /* Success, nothing read */
  }

  return -ENXIO; /* No such device or address */
}
