#include "pesp.h"

extern pespBuff_t pespBuff;
extern buff_Dt_t  buff_Dt[MAX_FD_NR];


extern unsigned long wr_nr;
extern unsigned long wr_usecs;
extern unsigned long wr_no_ptr_sw;
extern pid_t         wr_last_pid_no_ptr_sw;

extern unsigned long wr_no_upd[MAX_FD_NR];


extern struct timeval wr_end_time;

extern unsigned long __p;

extern long int buf_size;

#ifdef _WRBUFF_
  extern char * wr_buf;
#endif

extern struct work_memcpy *m_work;
extern struct workqueue_struct *wq;

//---------------------------------------------------------------------------
ssize_t pesp_write( struct file *filp, const char *buf,
                      size_t count, loff_t *f_pos)
{
  int retval;
  int x;
  int data_avail;
  #ifdef _WQMEMCPY_
  #else
  	int ret;
  	int i;
  	int rc[MAX_FD_NR];
  #endif
  #ifdef _WRBUFF_
  #endif
  int r;

  struct timeval t0;

  unsigned int dev_minor = iminor(filp->f_path.dentry->d_inode);

  do_gettimeofday(&t0);

  if ( dev_minor == 0 ){   // pespImg0, vecchio device
	__p = 1;

	x = atomic_read(&(pespBuff.inited));
	if (x != 1) {
  		printk(KERN_DEBUG "pesp_write(): called pespBuff.inited=%d\n", x);
		return 0;
  	} 

  	if ( count > buf_size ) {
  		printk(KERN_DEBUG "pesp_write(): count=%ld buf_size=%ld\n", count, buf_size);
		return -ENOMEM;
  	};

  	__p = 2;

	#ifdef _DBG
  		printk(KERN_DEBUG "pesp_write():\n");
	#endif

  	data_avail = 0;

  	#ifdef _WRBUFF_
    		if ( work_pending(&m_work->work_s) ) { // exit!
			printk(KERN_DEBUG "pesp_write().work_pending() true\n");
			return (0);
    		}
    		retval = copy_from_user(wr_buf, buf, count);
  	#endif

  	#ifdef _WQMEMCPY_
        	m_work->count = count;

		#ifdef _WQWQ_
    			r = queue_work( wq, &m_work->work_s ); // coda locale
		#else
			r = schedule_work(&m_work->work_s); // coda globale
		#endif
		if ( r==0 ) printk(KERN_DEBUG "pesp_write(): work on queue\n");

  	#else 
  		wr_nr++;

  		for (i=1; i<MAX_FD_NR; i++) {
			if (pespBuff.buff[i].want_update){
  				__p = 50 + i;
	  			ret = mutex_trylock(&pespBuff.buff[i].mtx);
  				__p = 100 + i;
	  			if (ret != 0) {
	  				// Got the lock!
  					__p = 200 + i;
  					#ifdef _WRBUFF_
						memcpy(pespBuff.buff[i].buff, wr_buf, count);
                                		pespBuff.buff[i].wr_count = count;
					#else
	  					rc[i] = copy_from_user(pespBuff.buff[i].buff, buf, count);
                                		pespBuff.buff[i].wr_count = count - rc[i];
  					#endif
  					__p = 210 + i;
	  				atomic_set(&(pespBuff.buff[i].st), 1);
	  				data_avail = 1;
  					__p = 230 + i;
	        			mutex_unlock(&pespBuff.buff[i].mtx);
  					__p = 300 + i;
	  			} else {
  					__p = 400 + i;
					wr_no_ptr_sw++;
					wr_last_pid_no_ptr_sw = pespBuff.buff[i].pid;
					wr_no_upd[i]++;
	      	  			printk(KERN_ALERT "pesp_write(): not lock, go ahead without ptr switch PID=%d comm=%s\n",
							pespBuff.buff[i].pid, pespBuff.buff[i].comm);
	  			}
			}
  		}

  		__p = 5;

  		for (i=1; i<MAX_FD_NR; i++) atomic_set(&(buff_Dt[i].st), 1);

		/* finally, awake any writers and return */
  		if (data_avail) wake_up_interruptible(&(pespBuff.queue));

  		__p = 6;
  	#endif

  	do_gettimeofday(&wr_end_time);
  	wr_usecs = (wr_end_time.tv_sec - t0.tv_sec)*1000000 + (wr_end_time.tv_usec - t0.tv_usec);

  	return (count-retval);
  } else 
  if (dev_minor == 1 ) { // pespDt0, nuovo device
  	printk(KERN_ALERT "pesp_write(): write file on minor 1 by PID: %d : %s\n", current->pid, current->comm);
        return 0; /* Success, nothing written */
  }

  return -ENXIO; /* No such device or address */

}
