#define  MAX_PROC_SIZE 100


#include "pesp.h"

#ifdef _HAVE_GC_
	extern gc_in_params_t gc_in_params;
#endif

extern char wclibuf[CLIBUFFSIZE];
extern char rclibuf[CLIBUFFSIZE];

#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,32)
	//---------------------------------------------------------------------------
	int pesp_wproc_gc_process(struct file *file, const char *buf, int count, void *data ){
		unsigned char val_char[MAX_PROC_SIZE+1];
		int v;
	
		memset(val_char, 0, MAX_PROC_SIZE+1);
	
		if(count > MAX_PROC_SIZE) count = MAX_PROC_SIZE;
	
		if(copy_from_user(val_char, buf, count)) return -EFAULT;
	
		if ( sscanf(val_char, "%d", &v) == 1 ) {
			printk(KERN_INFO "pesp_wproc_gc_process: %s %d", val_char, v);
			gc_in_params.gc_roi.process = v;
			return count;
		} else return -EINVAL;
	}
	
	//---------------------------------------------------------------------------
	int pesp_wproc_gc_qf_flag(struct file *file, const char *buf, int count, void *data ){
		unsigned char val_char[MAX_PROC_SIZE+1];
		int v;
	
		memset(val_char, 0, MAX_PROC_SIZE+1);
	
		if(count > MAX_PROC_SIZE) count = MAX_PROC_SIZE;
	
		if(copy_from_user(val_char, buf, count)) return -EFAULT;
	
		if ( sscanf(val_char, "%d", &v) == 1 ) {
			printk(KERN_INFO "pesp_wproc_gc_qf_flag: %s %d", val_char, v);
			gc_in_params.gc_roi.qf_flag = v;
			return count;
		} else return -EINVAL;
	}

	//---------------------------------------------------------------------------
        int pesp_wproc_cli(struct file *file, const char *buf, int count, void *data ){

		memset(wclibuf, 0, CLIBUFFSIZE);
		if (count < 0) return -EINVAL;
		if (count > 512) return -EINVAL; // vedi pesp_ioctl.h
		if (count >= CLIBUFFSIZE) return -EINVAL;
	
		if(copy_from_user(wclibuf, buf, count)) return -EFAULT;
		return count;
	}


#else /* LINUX_VERSION_CODE */

	//---------------------------------------------------------------------------
        ssize_t pesp_wproc_gc_process(struct file *file, const char * buf, size_t size, loff_t * ppos){
		unsigned char val_char[MAX_PROC_SIZE+1];
		int w;
	
		memset(val_char, 0, MAX_PROC_SIZE+1);
	
		if(size > MAX_PROC_SIZE) size = MAX_PROC_SIZE;
	
		if(copy_from_user(val_char, buf, size)) return -EFAULT;
	
		if ( sscanf(val_char, "%d", &w) == 1 ) {
			printk(KERN_INFO "pesp_wproc_gc_process: %s %d", val_char, w);
			gc_in_params.gc_roi.process = w;
			return size;
		} else return -EINVAL;
	}

	//---------------------------------------------------------------------------
        ssize_t pesp_wproc_gc_qf_flag(struct file *file, const char * buf, size_t size, loff_t * ppos){
		unsigned char val_char[MAX_PROC_SIZE+1];
		int w;
	
		memset(val_char, 0, MAX_PROC_SIZE+1);
	
		if(size > MAX_PROC_SIZE) size = MAX_PROC_SIZE;
	
		if(copy_from_user(val_char, buf, size)) return -EFAULT;
	
		if ( sscanf(val_char, "%d", &w) == 1 ) {
			printk(KERN_INFO "pesp_wproc_gc_qf_flag: %s %d", val_char, w);
			gc_in_params.gc_roi.qf_flag = w;
			return size;
		} else return -EINVAL;
	}


	//---------------------------------------------------------------------------
	ssize_t pesp_wproc_cli(struct file *file, const char *buf, size_t size, loff_t * ppos){
	
		int len = 0;
		#if 1
			memset(wclibuf, 0, CLIBUFFSIZE);
			if (size < 0) return -EINVAL;
			if (size > 512) return -EINVAL; // vedi pesp_ioctl.h
			if (size >= CLIBUFFSIZE) return -EINVAL;
	
			len = size;
	
			if(copy_from_user(wclibuf, buf, len)) return -EFAULT;
			//memcpy(rclibuf, wclibuf, CLIBUFFSIZE);
		#else
			printk(KERN_INFO "pesp_wproc_cli: buf=%p wclibuf=%p rclibuf=%p", buf, wclibuf, rclibuf);
			len = 1;
		#endif
		return len;
	}
#endif /* LINUX_VERSION_CODE */
