
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <errno.h>

#include "pesp_ioctl.h"


int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;
  int size = 1;
  int k = 0;

  char * input;

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);

	if (argc == 2){
		size = atoi(argv[1]);
	}

	retval = 0;
	input = malloc(size);
	if (input){
		while (1) {
			fd_set fds;
	                struct timeval tv, tr, t1, t2, t3;
	                int r;
	
	                FD_ZERO (&fds);
	                FD_SET (hamaBuf_fd, &fds);
	
	                /* Timeout. */
	                tv.tv_sec = 15;
	                tv.tv_usec = 0;
	
	                gettimeofday(&t1, NULL);
	                do {
	                	r = select (hamaBuf_fd + 1, &fds, NULL, NULL, &tv);
	                        if ((-1 == r) && !(EINTR == errno)) perror("select");
	                } while ( ((-1 == r)&&(EINTR == errno)) );

			k++;
	
	                if (0 == r) {
	                	printf("%d : select timeout\n", k);
	                } else {
	                        gettimeofday(&t2, NULL);
			        retval = read(hamaBuf_fd, input, size);
	                        gettimeofday(&t3, NULL);
	
				if ( retval < 0 ){
					perror("");
	    				close(hamaBuf_fd);
					return -1;
				} else {
					printf("%d : read! %d bytes in %ld usec\n", k, retval, (t3.tv_sec - t2.tv_sec)*1000000 + (t3.tv_usec - t2.tv_usec) );
				}
			};
	
			//printf("%d : retval = %d\n", k, retval);
		}

	} else {
		printf("Error on malloc()!\n");
	};
	
    	close(hamaBuf_fd);

}

