
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"


int main(){
  int hamaBuf_fd = 0;
  gc_in_params_t gc_in_params;
  int retval;


	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************

**********************************/

        retval = ioctl(hamaBuf_fd,PESP_IOCG_GC_PARAMS, &gc_in_params);          /* Get by pointer */
	printf("retval = %d\n", retval);

        printf("gc_in_params.gc_img.height                     = %d\n",  gc_in_params.gc_img.height);
        printf("gc_in_params.gc_img.width                      = %d\n",  gc_in_params.gc_img.width);
        printf("gc_in_params.gc_img.hor_calibration            = %g\n",  gc_in_params.gc_img.hor_calibration);
        printf("gc_in_params.gc_img.ver_calibration            = %g\n",  gc_in_params.gc_img.ver_calibration);
        printf("gc_in_params.gc_img.img_hor_pos_offset         = %g\n",  gc_in_params.gc_img.img_hor_pos_offset);
        printf("gc_in_params.gc_img.img_ver_pos_offset         = %g\n",  gc_in_params.gc_img.img_ver_pos_offset);

        printf("gc_in_params.gc_roi.type                       = [%d] ",  gc_in_params.gc_roi.type);
                switch ( gc_in_params.gc_roi.type){
                  case 0:   printf("disable_roi"); break;
                  case 1:   printf("manual_roi"); break;
                  case 2:   printf("auto_roi"); break;
                  case 3:   printf("auto_manual_roi"); break;
                  default:  printf("unknown");
                }
                printf("\n");
        printf("gc_in_params.gc_roi.process                    = [%d] ",  gc_in_params.gc_roi.process);
                switch ( gc_in_params.gc_roi.process){
                  case 0:   printf("disable process"); break;
                  case 1:   printf("enable process"); break;
                  default:  printf("unknown");
                }
                printf("\n");
        printf("gc_in_params.gc_roi.param[0] [hor_left]        = %d\n",  gc_in_params.gc_roi.param[0]);
        printf("gc_in_params.gc_roi.param[1] [ver_up]          = %d\n",  gc_in_params.gc_roi.param[1]);
        printf("gc_in_params.gc_roi.param[2] [hor_right        = %d\n",  gc_in_params.gc_roi.param[2]);
        printf("gc_in_params.gc_roi.param[3] [ver_down]        = %d\n",  gc_in_params.gc_roi.param[3]);
        printf("gc_in_params.gc_roi.threshold                  = %g\n",  gc_in_params.gc_roi.threshold);
        printf("gc_in_params.gc_roi.lp_order                   = %d\n",  gc_in_params.gc_roi.lp_order);
        printf("gc_in_params.gc_roi.hor_grid                   = %d\n",  gc_in_params.gc_roi.hor_grid);
        printf("gc_in_params.gc_roi.ver_grid                   = %d\n",  gc_in_params.gc_roi.ver_grid);
        printf("gc_in_params.gc_roi.search_background_param[0] = %g\n",  gc_in_params.gc_roi.search_background_param[0]);
        printf("gc_in_params.gc_roi.search_background_param[1] = %g\n",  gc_in_params.gc_roi.search_background_param[1]);

//    int32_t algorithm;                     // RAW_CALC, GAUSS_FIT, GAUSS_FIT_ASYMM, CONFITEOR_FIT,         "ImageProc.h" line 1732
//    int fast_calc;                      // decimate automatically the image to speedup calculations,    "ImageProc.h" line 174

	#ifndef IMGPROCNEW
	        printf("gc_in_params.algorithm                         = [%ld] ",  gc_in_params.algorithm);
	                switch (gc_in_params.algorithm){
	                  case 0:   printf("RAW_CALC"); break;
	                  case 1:   printf("GAUSS_FIT"); break;
	                  case 2:   printf("GAUSS_FIT_ASYMM"); break;
	                  case 3:   printf("CONFITEOR_FIT"); break;
	                  default:  printf("unknown");
	                }
	                printf("\n");
	        printf("gc_in_params.fast_calc                         = [%d] ",  gc_in_params.fast_calc);
	                switch (gc_in_params.fast_calc){
	                  case 0:   printf("NORM_CALC"); break;
	                  case 1:   printf("FAST_CALC"); break;
	                  default:  printf("unknown");
	                }
	                printf("\n");
	#else /* IMGPROCNEW */
        		printf("gc_in_params.cur_thres                         = %d\n",  gc_in_params.cur_thres);
	        	printf("gc_in_params.hor_algorithm                     = [%d] ",  gc_in_params.hor_algorithm);
	                switch (gc_in_params.hor_algorithm){
	                  case 0:   printf("RAW_CALC"); break;
	                  case 1:   printf("GAUSS_FIT"); break;
	                  case 2:   printf("GAUSS_FIT_ASYMM"); break;
	                  case 3:   printf("CONFITEOR_FIT"); break;
	                  default:  printf("unknown");
	                }
	                printf("\n");
			printf("gc_in_params.ver_algorithm                     = [%d] ",  gc_in_params.ver_algorithm);
				switch (gc_in_params.ver_algorithm){
				  case 0:   printf("RAW_CALC"); break;
				  case 1:   printf("GAUSS_FIT"); break;
				  case 2:   printf("GAUSS_FIT_ASYMM"); break;
				  case 3:   printf("CONFITEOR_FIT"); break;
				  default:  printf("unknown");
				}
				printf("\n");
	                printf("\n");
	        	printf("gc_in_params.hor_fast_calc_inc                 = [%d] ",  gc_in_params.hor_fast_calc_inc);
			if (gc_in_params.hor_fast_calc_inc == 0) printf("NORM_CALC");
			else if (gc_in_params.hor_fast_calc_inc > 0) printf("FAST_CALC");
			else printf("unknown");
	                printf("\n");
	        	printf("gc_in_params.ver_fast_calc_inc                 = [%d] ",  gc_in_params.ver_fast_calc_inc);
			if (gc_in_params.ver_fast_calc_inc == 0) printf("NORM_CALC");
			else if (gc_in_params.ver_fast_calc_inc > 0) printf("FAST_CALC");
			else printf("unknown");
	                printf("\n");

	                printf("\n");
        		//========================================================================================
        		// Quality Factor

        		//h_long qf_roi_1_param[4];
        		//h_long qf_roi_2_param[4];
        		printf("gc_in_params.gc_roi.qf_flag                             = %d\n",  gc_in_params.gc_roi.qf_flag);

        		printf("gc_in_params.gc_roi.qf_roi_1_param[0] [hor_left]        = %d\n",  gc_in_params.gc_roi.qf_roi_1_param[0]);
        		printf("gc_in_params.gc_roi.qf_roi_1_param[1] [ver_up]          = %d\n",  gc_in_params.gc_roi.qf_roi_1_param[1]);
        		printf("gc_in_params.gc_roi.qf_roi_1_param[2] [hor_right        = %d\n",  gc_in_params.gc_roi.qf_roi_1_param[2]);
        		printf("gc_in_params.gc_roi.qf_roi_1_param[3] [ver_down]        = %d\n",  gc_in_params.gc_roi.qf_roi_1_param[3]);
	                printf("\n");

        		printf("gc_in_params.gc_roi.qf_roi_2_param[0] [hor_left]        = %d\n",  gc_in_params.gc_roi.qf_roi_2_param[0]);
        		printf("gc_in_params.gc_roi.qf_roi_2_param[1] [ver_up]          = %d\n",  gc_in_params.gc_roi.qf_roi_2_param[1]);
        		printf("gc_in_params.gc_roi.qf_roi_2_param[2] [hor_right        = %d\n",  gc_in_params.gc_roi.qf_roi_2_param[2]);
        		printf("gc_in_params.gc_roi.qf_roi_2_param[3] [ver_down]        = %d\n",  gc_in_params.gc_roi.qf_roi_2_param[3]);
	                printf("\n");

	#endif /* IMGPROCNEW */

    	close(hamaBuf_fd);
}

