
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include <unistd.h>

#include <errno.h>



#include <dirent.h> // directory header


#include "pesp_ioctl.h"



static int cmpstringp(const void *p1, const void *p2) {
           return strcmp(p1,p2);
}



void usage(){
          printf("\n");
          printf("Usage: loopImageLoader dir tmo_ms\n");
          printf("\n");
          exit(-1);
}


int main(int argc, char *argv[]){

#define MAX_IMGS		1000
#define MAX_IMGFILENAMELENGTH	128

  char imgfile[MAX_IMGS][MAX_IMGFILENAMELENGTH];
  int k, i;

	if (argc < 2) usage();

	k=0;
//===========================================================================================================
                                                // first off, we need to create a pointer to a directory
    DIR *pdir = NULL;                           // remember, it's good practice to initialise a pointer to NULL!
    pdir = opendir (argv[1]);                      // "." will refer to the current directory
    struct dirent *pent = NULL;
    if (pdir == NULL)                           // if pdir wasn't initialised correctly
    {                                           // print an error message and exit the program
        printf ("\nERROR! pdir could not be initialised correctly");
        return -1;                              // exit the function
    } // end if

    while ( (pent = readdir (pdir)) )           // while there is still something in the directory to list
    {
        if (pent == NULL)                       // if pent has not been initialised correctly
        {                                       // print an error message, and exit the program
            printf ("\nERROR! pent could not be initialised correctly");
            return -2;                          // exit the function
        }
                                                // otherwise, it was initialised correctly. let's print it on the console:
	if ( strstr(pent->d_name, ".raw") ){
        	//printf("%s\n", pent->d_name);
		snprintf(imgfile[k], MAX_IMGFILENAMELENGTH, "%s", pent->d_name);
		k++;
	}
    }

                                                // finally, let's close the directory
    closedir (pdir);
//===========================================================================================================

	qsort(imgfile, k, MAX_IMGFILENAMELENGTH, cmpstringp);
	//for (i=0; i<k; i++) printf("%s\n", imgfile[i]);

//===========================================================================================================

  {
  int hamaBuf_fd = 0;
  int retval;
  int fd;
  unsigned char outbuf[10000000];
  int size;
  struct timeval t0, t1, r;
  struct stat st;
  float tmo = 0.0;

  int want_update = 0;


  char dest[MAX_IMGFILENAMELENGTH];

        if (argc < 3) usage();
	printf("argc=%d\n", argc);

        hamaBuf_fd = open("/dev/pespImg0", O_RDWR );
        if (hamaBuf_fd == -1){
		perror("");
		exit(-1);
	}
	retval = ioctl(hamaBuf_fd,PESP_IOCS_WANTUPDATE, want_update);
	
	tmo = atof(argv[2]);

	printf("2\n");

	while (1) {
		gettimeofday(&t0, NULL);
		for (i=0; i<k; i++){
			struct timeval tv = {0, 20000};   //
			tv.tv_sec = 0;
			tv.tv_usec = (long)(1000.0 * tmo);
	
			snprintf(dest, MAX_IMGFILENAMELENGTH, "%s/%s", argv[1], imgfile[i]);
	        	fd = open(dest, O_RDONLY);
		        fstat(fd, &st);
	        	size = st.st_size;
	
	        	retval = read(fd, outbuf, size);
	        	if (retval != size) printf("retval = %d\n", retval);
	        	close(fd);
	
	        	retval = write(hamaBuf_fd, outbuf, size);
	        	if (retval != size) printf("retval = %d\n", retval);
	
			if (select(0, NULL, NULL, NULL, &tv) < 0) perror("select");
		}
		gettimeofday(&t1, NULL);
		timersub(&t1, &t0, &r);
		printf("open/close %d file - write %9.1f msec each %9.1f msec\n",
			k,
			(float)r.tv_sec*1000+((float)r.tv_usec)/1000,
			((float)r.tv_sec*1000+((float)r.tv_usec)/1000)/k
			);
	};


        close(hamaBuf_fd);
  }



}
