
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"


void usage(){
	  printf("\n");
	  printf("Usage: setImage image[raw]\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;
  int fd;
  char *outbuf;
  int size;
  struct stat st;
  int want_update = 0;
  struct timeval t0, t1, T;
  int i;
  int t;
  int wrt;


	if (argc < 2) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
	//retval = ioctl(hamaBuf_fd,PESP_IOCS_WANTUPDATE, want_update);

	if (argc == 3) t = atoi(argv[2]);
	else t = 1;
	

	fd = open(argv[1], O_RDONLY);
	fstat(fd, &st);
	size = st.st_size;

	outbuf = malloc(size);
	if (outbuf) {
		retval = read(fd, outbuf, size);
        	printf("retval/bytes read = %d\n", retval);

	gettimeofday(&T, NULL);
	  for (i = 0; i < t; i ++ ){
		gettimeofday(&t0, NULL);
		retval = write(hamaBuf_fd, outbuf, size);
		gettimeofday(&t1, NULL);
		wrt = (t1.tv_sec - t0.tv_sec) * 1000000 + (t1.tv_usec - t0.tv_usec);

        	printf("%ld retval/written bytes = %d in %d [usec]\n",
			(t0.tv_sec - T.tv_sec) * 1000000 + (t0.tv_usec - T.tv_usec),
			retval, wrt);
		T.tv_sec = t0.tv_sec;
		T.tv_usec = t0.tv_usec;

		wrt = 20000 - wrt;
		if (wrt<0) wrt = 1;
		usleep (wrt);
	  };
	} else {
		printf("Error on malloc()!\n");
	}

	//usleep(1000000);

	close(fd);
    	close(hamaBuf_fd);
}
