
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"


void usage(){
	  printf("\n");
	  printf("Usage: setCCD CCDparameter value\n");
	  printf("      int width, height, depth\n");
	  printf("      struct timeval aet\n");
	  printf("      char smd, amd, emd\n");
	  printf("      unsigned short int ads\n");
	  printf("      char atp\n");
	  printf("      unsigned short int spx, spy\n");
	  printf("      int svo, svw, sho, shw\n");
	  printf("      char esc, res\n");
	  printf("      unsigned short int ceg, ceo\n");
	  printf("      unsigned short int ccdtype\n");
	  printf("      unsigned short int do_extra\n");
	  printf("      unsigned short int cooling\n");
	  printf("      float temp\n");
	  printf("      int target_temp\n");
	  printf("      int fast_trigger\n");
	  printf("      unsigned short int vsspeed\n");
	  printf("      float readouttime\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  h_ccd_t ccd;
  int retval;

	if (argc < 3) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }


/*********************************
struct _pespccd {
        int width, height, depth;
        struct timeval aet;
        char smd;
        char amd;
        char emd;
        unsigned short int ads;
        char atp;
        unsigned short int spx;
        int svo;
        int svw;
        int sho;
        int shw;
        char esc;
        unsigned short int ceg;
        unsigned short int ceo;
        char res;
};
**********************************/

	if ( strcmp(argv[1], "aet") == 0 ) {
		struct h_timeval tv;
			if (argc != 4) usage();
			printf("Writing %s\n", argv[1]);
			sscanf(argv[2], "%d", &tv.tv_sec);
			sscanf(argv[3], "%d", &tv.tv_usec);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_AET, &tv);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "smd") == 0 ) {
			printf("Writing %s\n", argv[1]);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_SMD, argv[2]);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "amd") == 0 ) {
			printf("Writing %s\n", argv[1]);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_AMD, argv[2]);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "emd") == 0 ) {
			printf("Writing %s\n", argv[1]);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_EMD, argv[2]);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "ads") == 0 ) {
		unsigned short int ads;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%hud", &ads);
			ccd.ads = ads;
			printf("Writing %s %d\n", argv[1], ads);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "atp") == 0 ) {
			printf("Writing %s\n", argv[1]);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_ATP, argv[2]);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "spx") == 0 ) {
		unsigned short int spx;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%hud", &spx);
			ccd.spx = spx;
			printf("Writing %s %d\n", argv[1], spx);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "spy") == 0 ) {
		unsigned short int spy;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%hud", &spy);
			ccd.spy = spy;
			printf("Writing %s %d\n", argv[1], spy);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "svo") == 0 ) {
		int svo;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &svo);
			ccd.svo = svo;
			printf("Writing %s %d\n", argv[1], svo);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "svw") == 0 ) {
		int svw;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &svw);
			ccd.svw = svw;
			printf("Writing %s %d\n", argv[1], svw);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "sho") == 0 ) {
		int sho;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &sho);
			ccd.sho = sho;
			printf("Writing %s %d\n", argv[1], sho);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "shw") == 0 ) {
		int shw;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &shw);
			ccd.shw = shw;
			printf("Writing %s %d\n", argv[1], shw);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "esc") == 0 ) {
			printf("Writing %s\n", argv[1]);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_ESC, argv[2]);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "ceg") == 0 ) {
		unsigned short int ceg;
			sscanf(argv[2], "%hud", &ceg);
			printf("Writing %s %d\n", argv[1], ceg);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CEG, &ceg);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "ceo") == 0 ) {
		unsigned short int ceo;
			sscanf(argv[2], "%hud", &ceo);
			printf("Writing %s %d\n", argv[1], ceo);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CEO, &ceo);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "res") == 0 ) {
		char res;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%c", &res);
			ccd.res = res;
			printf("Writing %s %c\n", argv[1], res);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "width") == 0 ) {
		int width;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &width);
			ccd.width = width;
			printf("Writing %s %d\n", argv[1], width);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "height") == 0 ) {
		int height;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &height);
			ccd.height = height;
			printf("Writing %s %d\n", argv[1], height);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "depth") == 0 ) {
		int depth;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &depth);
			ccd.depth = depth;
			printf("Writing %s %d\n", argv[1], depth);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "ccdtype") == 0 ) {
		unsigned short int ccdtype;
			sscanf(argv[2], "%hud", &ccdtype);
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			printf("Writing %s %d\n", argv[1], ccdtype);
			ccd.ccdtype = ccdtype;
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "temp") == 0 ) {
		float temp;
			sscanf(argv[2], "%f", &temp);
		    #if 0
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			printf("Writing %s %f\n", argv[1], temp);
			ccd.priv_data.andor.temp = temp;
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
		    #else
			printf("Writing %s %f\n", argv[1], temp);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_TEMP, &temp);          
			printf("retval = %d\n", retval);
		    #endif
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "do_extra") == 0 ) {
		unsigned short int do_extra;
			sscanf(argv[2], "%hud", &do_extra);
		    #if 0
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			ccd.do_extra = do_extra;
			printf("Writing %s %d\n", argv[1], do_extra);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
		    #else
			printf("Writing %s %u\n", argv[1], do_extra);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_DOEXTRA, &do_extra);          
			printf("retval = %d\n", retval);
		    #endif
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "cooling") == 0 ) {
		unsigned short int cooling;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%hud", &cooling);
			ccd.priv_data.andor.cooling = cooling;
			printf("Writing %s %d\n", argv[1], cooling);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "target_temp") == 0 ) {
		int temp;
			sscanf(argv[2], "%d", &temp);
			printf("Writing %s %d\n", argv[1], temp);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_WTEMP, &temp);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "fast_trigger") == 0 ) {
		int fast_trigger;
		bool ft;
			sscanf(argv[2], "%d", &fast_trigger);
			ft = (bool)fast_trigger;
			printf("Writing %s %d %d\n", argv[1], fast_trigger, ft);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_FASTTRIGGER, &ft);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "vsspeed") == 0 ) {
		int vsspeed;
		unsigned short int ft;
			sscanf(argv[2], "%d", &vsspeed);
			ft = (unsigned short int)vsspeed;
			printf("Writing %s %d %d\n", argv[1], vsspeed, ft);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VSSPEED, &ft);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "readouttime") == 0 ) {
		float rt;
			sscanf(argv[2], "%f", &rt);
			printf("Writing %s %f\n", argv[1], rt);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_READOUTTIME, &rt);          
			printf("retval = %d\n", retval);
	} else
	{} 



    	close(hamaBuf_fd);
}

