
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"


void usage(){
	  printf("\n");
	  printf("Usage: setHanaC8800 HamaC8800parameter value\n");
	  printf("      int width, height, depth\n");
	  printf("      float acqframerate\n");
	  printf("      bool darksubtract\n");
	  printf("      bool storedarkimg\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  h_virt_ccd_t pesp;
  int retval;

	if (argc < 3) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
struct _pesp {
        int width, height, depth;
        float acqframerate;
        bool darksubtract;
};

**********************************/

	if ( strcmp(argv[1], "width") == 0 ) {
		int width;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &width);
			pesp.width = width;
			printf("Writing %s %d\n", argv[1], width);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VCCD, &pesp);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "height") == 0 ) {
		int height;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &height);
			pesp.height = height;
			printf("Writing %s %d\n", argv[1], height);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VCCD, &pesp);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "depth") == 0 ) {
		int depth;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &depth);
			pesp.depth = depth;
			printf("Writing %s %d\n", argv[1], depth);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VCCD, &pesp);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "acqframerate") == 0 ) {
		float acqframerate;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%f", &acqframerate);
			pesp.acqframerate = acqframerate;
			printf("Writing %s %f\n", argv[1], acqframerate);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VCCD, &pesp);          
			printf("retval = %d\n", retval);
	} else 
	if ( strcmp(argv[1], "darksubtract") == 0 ) {
		bool darksubtract;
		int v;
			printf("Read & Write\n");
			retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          
        		printf("Read retval = %d\n", retval);
			sscanf(argv[2], "%d", &v);
			darksubtract = (bool)v;
			pesp.darksubtract = darksubtract;
			printf("Writing %s %d\n", argv[1], darksubtract);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_VCCD, &pesp);          
			printf("retval = %d\n", retval);
	} else
	if ( strcmp(argv[1], "storedarkimg") == 0 ) {
		uint32_t hamacmd;
			printf("Read & Write\n");
                	retval = ioctl(hamaBuf_fd, PESP_IOCG_CMD, &hamacmd);
        		printf("Read retval = %d\n", retval);
                        hamacmd |= (uint32_t)0x1;
			printf("Writing  %u\n", hamacmd);
                        retval = ioctl(hamaBuf_fd, PESP_IOCT_CMD, hamacmd);
			printf("retval = %d\n", retval);
	} 


    	close(hamaBuf_fd);
}

