

#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include <time.h>


#include <dirent.h> // directory header


#include "pesp_ioctl.h"

#include "lib_h_image.h"


#undef _DBG_

static int cmpstringp(const void *p1, const void *p2) {
           return strcmp(p1,p2);
}



void usage(){
          printf("\n");
          printf("Usage: loopImageLoader dir\n");
          printf("\n");
          exit(-1);
}


int main(int argc, char *argv[]){

#define MAX_IMGS		1000
#define MAX_IMGFILENAMELENGTH	128

  char imgfile[MAX_IMGS][MAX_IMGFILENAMELENGTH];
  int k, i;

  
  char *imgfileptr[MAX_IMGS];

	if (argc < 2) usage();

	k=0;
//===========================================================================================================
                                                // first off, we need to create a pointer to a directory
    DIR *pdir = NULL;                           // remember, it's good practice to initialise a pointer to NULL!
    pdir = opendir (argv[1]);                      // "." will refer to the current directory
    struct dirent *pent = NULL;
    if (pdir == NULL)                           // if pdir wasn't initialised correctly
    {                                           // print an error message and exit the program
        printf ("\nERROR! pdir could not be initialised correctly");
        return -1;                              // exit the function
    } // end if

    while ( (pent = readdir (pdir)) )           // while there is still something in the directory to list
    {
        if (pent == NULL)                       // if pent has not been initialised correctly
        {                                       // print an error message, and exit the program
            printf ("\nERROR! pent could not be initialised correctly");
            return -2;                          // exit the function
        }
                                                // otherwise, it was initialised correctly. let's print it on the console:
	if ( strstr(pent->d_name, ".raw") ){
        	//printf("%s\n", pent->d_name);
		snprintf(imgfile[k], MAX_IMGFILENAMELENGTH, "%s", pent->d_name);
		k++;
	}
    }

                                                // finally, let's close the directory
    closedir (pdir);
//===========================================================================================================

	qsort(imgfile, k, MAX_IMGFILENAMELENGTH, cmpstringp);
	//for (i=0; i<k; i++) printf("%s\n", imgfile[i]);

//===========================================================================================================

  
  {
  char dest[MAX_IMGFILENAMELENGTH];
  int fd;
  int retval;
  struct timeval t0, t1, r;
  int _flg = 0;

	printf("Pre load of images ...\n");
	gettimeofday(&t0, NULL);
	for (i=0; i<k; i++){
		imgfileptr[i] = malloc(PESP_BUFFSIZE);
		snprintf(dest, MAX_IMGFILENAMELENGTH, "%s/%s", argv[1], imgfile[i]);
        	fd = open(dest, O_RDONLY);
        	retval = read(fd, imgfileptr[i], PESP_BUFFSIZE);
        	if (retval != PESP_BUFFSIZE) printf("retval = %d\n", retval);

		retval = mlock(imgfileptr[i], PESP_BUFFSIZE);
		if ( (retval !=0) && !_flg) {
			printf("%d  ", i);
			perror(NULL);
			_flg = 1;
			printf("going on without mlock()\n");
		}
        	close(fd);
	}
	gettimeofday(&t1, NULL);
	timersub(&t1, &t0, &r);
	printf("open/close %d file %6.1f msec each %6.1f msec\n",
		k,
		(float)r.tv_sec*1000+((float)r.tv_usec)/1000,
		((float)r.tv_sec*1000+((float)r.tv_usec)/1000)/k
		);
  }

  {
  int hamaBuf_fd = 0;
  int retval;
  h_img_t outbuf;
  int size;
  struct timeval t0, t1, r;
  struct timeval t2, t3, t4;

  int32_t lbn = 0;
  struct h_timeval tv;

  time_t nowtime;
  struct tm *nowtm;
  char tmbuf[64], buf[64];

  gc_in_params_t gc_in_params;
  h_virt_ccd_t vccd;
  h_ccd_t ccd;

  int j, a, b;
  int want_update = 0;

  int flag = 1;

  a = 0;
  b = 0;

  ptimer_t pt;

        hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
	retval = ioctl(hamaBuf_fd,PESP_IOCS_WANTUPDATE, want_update);


	printf("Go loop ...\n");
	while (1) {
		for (i=0; i<k; i++){
			gettimeofday(&t2, NULL);
			
			#ifdef _DBG_
			printf("bn = %ld  |  ", h_ImageGetBN((h_img_t*)imgfileptr[i]));
			printf("imgNo = %ld  |  ", h_ImageGetNo((h_img_t*)imgfileptr[i]));
			#endif /* _DBG_ */

			h_ImageSetBN((h_img_t*)imgfileptr[i], lbn);
			h_ImageSetNo((h_img_t*)imgfileptr[i], lbn);
			#ifdef _DBG_
			printf("new bn = %ld  |  ", h_ImageGetBN((h_img_t*)imgfileptr[i]));
			printf("new imgNo = %ld  |  ", h_ImageGetNo((h_img_t*)imgfileptr[i]));
			//printf("\n");
			#endif /* _DBG_ */

			tv = h_ImageGetTv((h_img_t*)imgfileptr[i]);
	                nowtime = tv.tv_sec;
	                nowtm = localtime(&nowtime);
	                strftime(tmbuf, sizeof tmbuf, "%Y-%m-%d %H:%M:%S", nowtm);
	                snprintf(buf, sizeof buf, "%s.%06d", tmbuf, tv.tv_usec);
			#ifdef _DBG_
			printf(" %s", buf);
			//printf("\n");
			#endif /* _DBG_ */

			gettimeofday(&t0, NULL);
			tv.tv_sec = (h_time_t)t0.tv_sec;
			tv.tv_usec = (h_suseconds_t)t0.tv_usec;
			h_ImageSetTv((h_img_t*)imgfileptr[i], tv);

			tv = h_ImageGetTv((h_img_t*)imgfileptr[i]);
	                nowtime = tv.tv_sec;
	                nowtm = localtime(&nowtime);
	                strftime(tmbuf, sizeof tmbuf, "%Y-%m-%d %H:%M:%S", nowtm);
	                snprintf(buf, sizeof buf, "%s.%06d", tmbuf, tv.tv_usec);
			#ifdef _DBG_
			printf(" NEW %s", buf);
			printf("\n");
			#endif /* _DBG_ */

			ccd = h_ImageGetCCD((h_img_t*)imgfileptr[i]);


			#if 1
				retval = ioctl(hamaBuf_fd, PESP_IOCS_CCD, &ccd);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_CCD) retval= %d\n", retval);
				#endif /* _DBG_ */

			#else
				retval = ioctl(hamaBuf_fd, PESP_IOCS_AET, &ccd.aet);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_AET) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SMD, &ccd.smd);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SMD) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_AMD, &ccd.amd);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_AMD) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_EMD, &ccd.emd);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_EMD) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_ADS, &ccd.ads);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_ADS) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_ATP, &ccd.atp);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_ATP) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SPX, &ccd.spx);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SPX) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SVO, &ccd.svo);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SVO) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SVW, &ccd.svw);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SVW) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SHO, &ccd.sho);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SHO) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_SHW, &ccd.shw);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_SHW) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_ESC, &ccd.esc);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_ESC) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_CEG, &ccd.ceg);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_CEG) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_CEO, &ccd.ceo);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_CEO) retval= %d\n", retval);
				#endif /* _DBG_ */
	
				retval = ioctl(hamaBuf_fd, PESP_IOCS_RES, &ccd.res);
				#ifdef _DBG_
					printf("ioctl(PESP_IOCS_RES) retval= %d\n", retval);
				#endif /* _DBG_ */

			#endif
	


			vccd = h_ImageGetVCCD((h_img_t*)imgfileptr[i]);
			retval = ioctl(hamaBuf_fd,PESP_IOCS_VCCD, &vccd);
			
			if (flag) {
				flag = 0;
				gc_in_params = h_ImageGetGCIn((h_img_t*)imgfileptr[i]);
				retval = ioctl(hamaBuf_fd,PESP_IOCS_GC_PARAMS, &gc_in_params);
			}
			#ifdef _DBG_SIMPLE_GC
				printf("gc_in_params.algorithm= %d\n", gc_in_params.algorithm);
			#endif

			#if 1
				// 1 000 000 ca 3-4 ms
				for (j=0; j<2000000; j++) a = b + 1;
			#endif

       		 	retval = write(hamaBuf_fd, imgfileptr[i], PESP_BUFFSIZE);
       		 	//if (retval != PESP_BUFFSIZE) printf("retval = %d\n", retval);

			gettimeofday(&t4, NULL);
			timersub(&t4, &t2, &r);

			pt.which = 0;
			pt.t.tv_sec = r.tv_sec;
			pt.t.tv_usec = r.tv_usec;
			retval = ioctl(hamaBuf_fd, PESP_IOCS_PTIMERS, &pt);

			lbn++;
			#if 1
				usleep(100000);
			#else
				usleep(10000);
			#endif

			gettimeofday(&t3, NULL);
			timersub(&t3, &t2, &r);

			#ifdef _DBG_SIMPLE_PRT_TIME
				printf("Loop time = %f ms\n", r.tv_sec*1000+((float)r.tv_usec)/1000);
			#endif /* _DBG_SIMPLE_PRT_TIME */

			pt.which = 1;
			pt.t.tv_sec = r.tv_sec;
			pt.t.tv_usec = r.tv_usec;
			retval = ioctl(hamaBuf_fd, PESP_IOCS_PTIMERS, &pt);
		}
	}


        close(hamaBuf_fd);
  }



}
