
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include <errno.h>


#include "pesp_ioctl.h"



int main(){
  int fd = 0;
  int retval;

  struct timeval t0, t1, td;
  float tf;


	fd = open("/dev/pespDt0", O_RDWR);

	if (fd == -1) {
		perror("");
		return -1;
	}
	printf("fd = %d\n", fd);

	gettimeofday(&t0, NULL);
	while (1) {
        	fd_set fds;
                struct timeval tv;
                int r;
		unsigned char c[2];

                FD_ZERO (&fds);
                FD_SET (fd, &fds);

                /* Timeout. */
                tv.tv_sec = 2;
                tv.tv_usec = 0;

                do {
                	r = select (fd + 1, &fds, NULL, NULL, &tv);
                        if ((-1 == r) && !(EINTR == errno)) perror("select");
                } while ( ((-1 == r)&&(EINTR == errno)) );

                if (0 == r) {
                	printf("Waiting for new image data: select timeout\n");
                } else {
			gettimeofday(&t1, NULL);
			printf("got! time: %d.%06d: ", t1.tv_sec, t1.tv_usec);
			retval = read(fd, c, 1);
			timersub(&t1, &t0, &td);
			t0 = t1;
			tf = td.tv_sec * 1000 + ((float)td.tv_usec)/1000;
			printf("diff = %6.3f [ms]\n", tf);
		}
	}


    	close(fd);
}

